SystemOrganization addCategory: #'Magritte-Tests-Json'!

GRObject subclass: #MJTestAddress
	instanceVariableNames: 'postalCode city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
city
	^ city! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
city: anObject
	city := anObject! !

!MJTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 2/3/2012 15:26'!
descriptionCity
	<magritteDescription>
	^ MAStringDescription new
		accessor: #city;
		label: 'City';
		beXmlElement;
		priority: 20;
		yourself! !

!MJTestAddress methodsFor: 'accessing-magritte' stamp: 'NickAger 2/3/2012 15:26'!
descriptionPostalCode
	<magritteDescription>
	^ MAStringDescription new
		accessor: #postalCode;
		label: 'Postal Code';
		beXmlAttribute;
		priority: 15;
		yourself! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
postalCode
	^ postalCode! !

!MJTestAddress methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:26'!
postalCode: anObject
	postalCode := anObject! !

GRObject subclass: #MJTestPerson
	instanceVariableNames: 'name address favouriteHobby otherHobbies otherAddresses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestPerson class methodsFor: 'defaults' stamp: 'NickAger 2/3/2012 15:23'!
allHobbies

	^#( 'Tennis' 'Golf' 'Football' 'Chess' 'Smalltalk programming' )! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
address
	^ address! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
address: anObject
	address := anObject! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:27'!
descriptionAddress
	<magritteDescription>
	^ MAToOneRelationDescription new
		accessor: #address;
		label: 'Address';
		classes: (Array with: MJTestAddress);
		priority: 20;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:27'!
descriptionFavouriteHobby
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #favouriteHobby;
		label: 'Favourite hobby';
		options: self class allHobbies;
		priority: 30;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:27'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 10;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:28'!
descriptionOtherAddresses
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #otherAddresses;
		label: 'Other addresses';
		classes: (Array with: MJTestAddress);
		priority: 40;
		yourself! !

!MJTestPerson methodsFor: 'accessing-description' stamp: 'NickAger 2/3/2012 15:23'!
descriptionOtherHobbies
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #otherHobbies;
		label: 'Other hobbies';
		options: self class allHobbies;
		beXmlElement;
		priority: 50;
		yourself! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
favouriteHobby
	^ favouriteHobby! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
favouriteHobby: anObject
	favouriteHobby := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
name
	^ name! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
name: anObject
	name := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherAddresses
	^ otherAddresses! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherAddresses: anObject
	otherAddresses := anObject! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherHobbies
	^ otherHobbies! !

!MJTestPerson methodsFor: 'accessing' stamp: 'NickAger 2/3/2012 15:23'!
otherHobbies: anObject
	otherHobbies := anObject! !

TestCase subclass: #MJTestAsJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestAsJson methodsFor: 'tests' stamp: 'NickAger 2/3/2012 16:30'!
testAsJson
	| person |
	person := MJTestPerson new name: 'Philippe'; yourself.
	self assert: person asJson equals: '{"Name":"Philippe"}'! !

TestCase subclass: #MJTestFromJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Json'!

!MJTestFromJson methodsFor: 'tests' stamp: 'NickAger 2/3/2012 16:22'!
testFromJson
	| person |
	person := MJTestPerson fromJson:  '{"Name":"Philippe"}'.  

	self assert:  person name equals:  'Philippe'! !
